unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Tabnotbk, ExtCtrls, Grids, Menus;

type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    Deleteentry1: TMenuItem;
    Addentry1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button1: TButton;
    Panel2: TPanel;
    ListBox1: TListBox;
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    IncludeList: TMemo;
    Label2: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label5: TLabel;
    Memo1: TMemo;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Button4: TButton;
    Label7: TLabel;
    Edit5: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Deleteentry1Click(Sender: TObject);
    procedure Addentry1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
    CurrentSection:String;
    thefilename:String;
    procedure CheckWidths;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses registry, inifiles, Unit2;

procedure SetPrivilege;
var
  hToken: THandle;
  tp : TTokenPrivileges;
  tpOld : TTokenPrivileges;
  ID : TLargeInteger;
  Ret : DWord;
begin
  OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken);
  LookupPrivilegeValue(nil, 'SeBackupPrivilege', ID);

  tp.PrivilegeCount := 1;
  tp.Privileges[0].Luid := ID;
  tp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;

  if not (AdjustTokenPrivileges(hToken, False, tp, SizeOf(tp), tpOld, Ret))
  then
    begin
      MessageBeep(mb_iconerror);
      MessageBox(0, 'Privilegien nicht erlaubt!', 'Test', mb_ok or mb_iconerror);
      Exit;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  aregistry:TRegIniFile;
  j,k,akey:integer;
  result:array[0..256] of char;
  resultlen:integer;
  keys, values:Tstrings;
  aninifile:Tinifile;
begin
  aregistry:=TRegIniFile.Create('Sample');
  deletefile(extractfilepath(paramstr(0))+edit2.text);
  aninifile:=TInifile.Create(extractfilepath(paramstr(0))+edit2.text);
  with aregistry do
  begin
    RootKey := HKEY_CURRENT_USER;
    keys:=Tstringlist.create;
    values:=Tstringlist.create;
    openkey(edit1.text,false);
    ReadSections(keys);
    aninifile.writeinteger('SavedKeys','Count',j);
    anIniFile.WriteString('Project_Options','FileName',edit3.text);
    anIniFile.WriteString('Project_Options','OpenWith',edit5.text);
    anIniFile.WriteString('Project_Options','Regpath',edit1.text);
    listbox1.items.clear;
    for j := 1 to keys.count do    // Iterate
    begin
      values.clear;
      aninifile.writestring('SavedKeys','Key'+inttostr(j),keys[j-1]);
      if IncludeList.lines.indexof(keys[j-1])>-1 then
        listbox1.items.add(keys[j-1]);
      ReadSectionvalues(edit1.text+keys[j-1],values);
      for k := 1 to values.count do    // Iterate
        aninifile.writestring(keys[j-1],values.names[k-1],values.values[values.names[k-1]]);
    end;    // for
    free;
  end;
  aninifile.free;
  Combobox1.items.add(edit2.text);
end;


procedure TForm1.ListBox1Click(Sender: TObject);
var
  j: integer;
  aninifile:TInifile;
  anedit: TEdit;
  alabel: TLabel;
  values:TStrings;
begin
  aninifile:=TInifile.create(thefilename);
  if currentSection<>'' then
  begin
    aninifile.erasesection(CurrentSection);
    for j := 1 to stringgrid1.RowCount do    // Iterate
      if stringgrid1.cells[0,j-1]<>'' then
        aninifile.writestring(Currentsection,stringgrid1.cells[0,j-1],stringgrid1.cells[1,j-1]);
  end;
  if listbox1.itemindex>-1 then
    CurrentSection:=listbox1.items[listbox1.itemindex]
  else
    CurrentSection:='';
  values:=TStringlist.Create;
  try
    aninifile.ReadSectionValues(CurrentSection,values);
  except
  end;
  aninifile.free;
  Stringgrid1.rowcount:=values.count;
  Stringgrid1.cells[0,0]:='';
  Stringgrid1.cells[1,0]:='';
  for j := 1 to values.count do    // Iterate
  begin
    stringgrid1.cells[0,j-1]:=values.names[j-1];
    stringgrid1.cells[1,j-1]:=values.values[values.names[j-1]];
  end;    // for
  CheckWidths;
end;

procedure TForm1.Deleteentry1Click(Sender: TObject);
var col1, col2 :TStringlist;
begin
  col1:=Tstringlist.Create;
  col2:=Tstringlist.Create;
  col1.Assign(Stringgrid1.Cols[0]);
  col2.Assign(Stringgrid1.Cols[1]);
  col1.delete(Stringgrid1.Row);
  col2.delete(Stringgrid1.Row);
  Stringgrid1.RowCount:=col1.count;
  Stringgrid1.cells[0,0]:='';
  Stringgrid1.cells[1,0]:='';
  Stringgrid1.Cols[0].Assign(col1);
  Stringgrid1.Cols[1].Assign(col2);
  col1.free;
  col2.free;
end;

procedure TForm1.CheckWidths;
var j: Integer;
    maxwidthleft, maxwidthright: integer;
begin
  maxwidthleft:=1;
  maxwidthright:=1;
  for j := 0 to Stringgrid1.RowCount-1 do    // Iterate
  begin
    if stringgrid1.canvas.textwidth(Stringgrid1.cells[1,j])>maxwidthright then
      maxwidthright:=stringgrid1.canvas.textwidth(Stringgrid1.cells[1,j]);
    if stringgrid1.canvas.textwidth(Stringgrid1.cells[0,j])>maxwidthleft then
      maxwidthleft:=stringgrid1.canvas.textwidth(Stringgrid1.cells[0,j]);
  end;    // for
  stringgrid1.colwidths[0]:=maxwidthleft+10;
  stringgrid1.colwidths[1]:=maxwidthright+10;
end;

procedure TForm1.Addentry1Click(Sender: TObject);
begin
  if form2.showmodal=mrok then
  begin
    Stringgrid1.RowCount:=Stringgrid1.RowCount+1;
    Stringgrid1.Row:=Stringgrid1.RowCount-1;
    Stringgrid1.Cells[0,Stringgrid1.Row]:=form2.edit1.text;
    Stringgrid1.Cells[1,Stringgrid1.Row]:=form2.edit2.text;
    Stringgrid1.Col:=1;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var keys:TStrings;
  j: integer;
  aninifile: TInifile;
begin
  if listbox1.items.count>0 then
    listbox1click(self);
  CurrentSection:='';
  keys:=TStringlist.Create;
  thefilename:=extractfilepath(paramstr(0))+combobox1.text;
  aninifile:=TInifile.create(thefilename);
  aninifile.readsectionvalues('SavedKeys',keys);
  Listbox1.items.clear;
  for j := 2 to keys.count do    // Iterate
    if Includelist.lines.indexof(keys.values[keys.names[j-1]])>-1 then
      Listbox1.items.add(keys.values[keys.names[j-1]]);
  aninifile.free;
  keys.free;
  Listbox1.itemindex:=0;
  if Listbox1.items.count>0 then
    Listbox1Click(self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  aninifile: TInifile;
begin
  if Listbox1.items.count>0 then
    Listbox1Click(self);
  Combobox1.items.Savetofile(extractfilepath(paramstr(0))+'projects.ini');

  aninifile:=TInifile.create(extractfilepath(paramstr(0))+'settings.ini');
  aninifile.writestring('Options','Delphi3EXE',edit5.text);
  aninifile.writestring('Options','D3RegPath',edit1.text);
  memo1.lines.SaveToFile(extractfilepath(paramstr(0))+'settings.lst');
  aninifile.free;
end;

procedure TForm1.FormShow(Sender: TObject);
var aninifile:TInifile;
begin
  aninifile:=TInifile.create(extractfilepath(paramstr(0))+'settings.ini');
  edit5.text:=aninifile.readstring('Options','Delphi3EXE','');
  edit1.text:=aninifile.readstring('Options','D3RegPath','\Software\Borland\Delphi\3.0\');
  if fileexists(extractfilepath(paramstr(0))+'settings.lst') then
    memo1.lines.LoadFromFile(extractfilepath(paramstr(0))+'settings.lst');
  aninifile.free;
  if fileexists(extractfilepath(paramstr(0))+'projects.ini') then
    Combobox1.items.LoadFromFile(extractfilepath(paramstr(0))+'projects.ini');
  if Combobox1.Items.Count>0 then
  begin
    Combobox1.Itemindex:=0;
    Combobox1Change(self);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if opendialog1.execute then
    edit3.text:=opendialog1.filename;
end;


procedure TForm1.Button3Click(Sender: TObject);
var keys, values:TStrings;
  startprog: String;
  k: integer;
  ReginiFile: TReginiFile;
  j: integer;
  aninifile: TInifile;
  path: String;
begin
  keys:=TStringlist.Create;
  values:=TStringlist.Create;
  aninifile:=TInifile.create(thefilename);
  startprog:=aninifile.readstring('Project_options','OpenWith','');
  path:=aninifile.readstring('Project_options','RegPath','');
  if path='' then
    exit;

  ReginiFile:=TReginiFIle.Create('Sample');
  aninifile.readsectionvalues('SavedKeys',keys);
  RegInifile.RootKey:=HKey_Current_User;
  RegIniFile.OpenKey(path,true);
  Listbox1.items.clear;
  for j := 2 to keys.count do    // Iterate
    if Includelist.lines.indexof(keys.values[keys.names[j-1]])>-1 then
    begin
      Listbox1.items.add(keys.values[keys.names[j-1]]);
      values.clear;
      aninifile.readsectionvalues(keys.values[keys.names[j-1]], values);
      RegIniFile.EraseSection(keys.values[keys.names[j-1]]);
      for k := 1 to values.count do    // Iterate
      begin
        RegIniFile.WriteString(keys.values[keys.names[j-1]],values.names[k-1],values.values[values.names[k-1]]);
      end;    // for
    end;
  RegIniFile.free;
  aninifile.free;
  values.free;
  keys.free;
  winexec(pchar(startprog),sw_show);
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  deletefile(thefilename);
  Combobox1.items.delete(Combobox1.items.indexof(Combobox1.text));
  Combobox1Change(self);
end;


end.



